/*
 * Fibonocci demo
 * CSE142 Au 99  HP
 */

#include <stdio.h>

/* 
 * The Fibonocci numbers are the sequence
 *		fib(0) = 1
 *		fib(1) = 1
 *		fib(n) = fib(n-1) + fib(n-2) for n > 1
 */

/* = nth fibonocci number iteratively */
int wfib(int n) {
	int k;
	int ans;	/* fib(k)   */
	int km1;	/* fib(k-1) */
	int km2;	/* fib(k-2) */

	if (n <= 1)
		ans = 1;
	else {
		km1 = 1;
		ans = 1;
		for (k = 2; k <= n; k++) {
			km2 = km1;
			km1 = ans;
			ans = km1 + km2;
		}
	}
	return ans;
}

/* = nth fibonocci number recursively */
int rfib(int n) {
	if (n <= 1)
		return 1;
	else
		return rfib(n-1) + rfib(n-2);	
}


int main(void) {
	int k, fib;

	while(1) {
		printf("enter a number: ");
		scanf("%d", &k);
		if (k < 0)
			return 0;
		fib = wfib(k);
		printf("%dth Fibonocci # = %d (loop)\n\n", k, fib);
		fib = rfib(k);
		printf("%dth Fibonocci # = %d (recursive)\n\n", k, fib);
	}
}